%TestColor

%Load spectral data
letters = 'FGHI'; 
for j=1:length(letters)
    for i=1:6
        strings{(6*(j-1))+i}=[letters(j) num2str(i) '.ProcSpec'];
    end
end

R_spec = zeros(length(strings), 2048);
slam = zeros(1, 2048);
for i = 1:length(strings)
[R_data(i,:), slam(:)] = Proc2R(['Spectrometer\' strings{i}]);
end
R = R_data;
R(:,1) = R(:,2);

%Load HSI data
info = readHyperHeader('Grey450-808.hdr');
dark = multibandread('Dark450-808.bip', [info.lines,info.samples,info.bands], info.data_type, 0, info.interleave, 'ieee-le');
gray = multibandread('Grey450-808.bip', [info.lines,info.samples,info.bands], info.data_type, 0, info.interleave, 'ieee-le');
img = multibandread('Color450-808.bip', [info.lines,info.samples,info.bands], info.data_type, 0, info.interleave, 'ieee-le');
[imgD] = SubDark(img,dark);
[grayD] = SubDark(gray,dark);

%Stract wavelengths vector
ilam = zeros(1,info.bands);
a=1;
for i=2:8:1439
    ilam(a)=str2double(info.band_names(i:i+2));
    a = a+1;
end

%Reflectance image
imgR = img2R(imgD,grayD, ilam);
for k=1:length(imgR(:,1,1))
    iColor(:,:,k) = imgR(k,:,:);
end

% Select area of each of the squares that will be analyzed
squares{1}='red';
coordinates(1,:) = floor([500.208528892673 410.362660250495 136.780142916271 131.973173037425]);
imgColorRed = imgR(:,coordinates(1,2):coordinates(1,2)+coordinates(1,4),coordinates(1,1):coordinates(1,1)+coordinates(1,3));
squares{2}='blue';
coordinates(2,:) = floor([656.130567873183 569.072442739442 132.337000249194 127.686179154175]);
imgColorBlue = imgR(:,coordinates(2,2):coordinates(2,2)+coordinates(2,4),coordinates(2,1):coordinates(2,1)+coordinates(2,3));
squares{3}='yellow';
coordinates(3,:) = floor([45.9356653244576 570.255557252473 121.787639168145 117.507562392268]);
imgColorYellow= imgR(:,coordinates(3,2):coordinates(3,2)+coordinates(3,4),coordinates(3,1):coordinates(3,1)+coordinates(3,3));

for i=1:116 ...
for j=1:122 ...
imgColorRed(:,i,j) = imgColorRed(:,i,j)/norm(imgColorRed(:,i,j));
imgColorBlue(:,i,j) = imgColorBlue(:,i,j)/norm(imgColorBlue(:,i,j));
imgColorYellow(:,i,j) = imgColorYellow(:,i,j)/norm(imgColorYellow(:,i,j));
end;end

%Get spectrum
specRed = mean(mean(imgColorRed,3),2);
specBlue = mean(mean(imgColorBlue,3),2);
specYellow = mean(mean(imgColorYellow,3),2);

%plot
n = 25;
Xred = R(10, n:802);
Yred = 2*interp1(ilam, specRed, slam(n:802));
Hred = Yred./Xred;
plot(slam(n:802),Xred)
hold on
plot(slam(n:802),Yred')
hold on
plot(slam(n:802),Hred','--')
axis([500 800 0.5 1.5])
xlabel('Wavelength')
ylabel('Reflectance')
title('Spectrum red square')
legend('H response')

figure(2);
n = 25;
Xblue = R(17, n:802);
Yblue = 2*interp1(ilam, specBlue, slam(n:802));
Hblue = Yblue./Xblue;
plot(slam(n:802),Xblue)
hold on
plot(slam(n:802),Yblue')
hold on
plot(slam(n:802),Hblue','--')
axis([500 800 0.5 1.5])
xlabel('Wavelength')
ylabel('Reflectance')
title('Spectrum blue square')
legend('H response')
figure(3);
n = 25;
Xyellow = R(13, n:802);
Yyellow = 8*interp1(ilam, specYellow, slam(n:802));
Hyellow = Yyellow./Xyellow;
plot(slam(n:802),Xyellow)
hold on
plot(slam(n:802),Yyellow')
hold on
plot(slam(n:802),Hyellow','--')
axis([500 800 0.5 1.5])
xlabel('Wavelength')
ylabel('Reflectance')
title('Spectrum yellow square')
legend('H response')










