%Code available to control AOTF in matlab

% Full control AOTF
freq = (sqrt(sin(200./wavelengths)+1)).^(10.55)*20.91950466; %frequency in (MHz)
Nlam = length(wavelengths);

% Initialize
[ser]=initAOTF(mPow);

% Set frequency
liveflag = 0; channel = 6;
[chFRhex] = GetChRF(liveflag, channel, freq(1), 0); %%% Amplitude 0 so f is not important
[out] = sendHex2RF(ser,chFRhex);

% Example of HSI loop
liveflag = 0; channel = 6;
for i = 1:Nlam
    %set frequency    
    [chFRhex] = GetChRF(liveflag, channel, freq(i), mPow); %%% MPOW SHOULD BE AMPLITUDE. CHECK
    [out] = sendHex2RF(ser,chFRhex);
    %get image
    trigger(vid); %acqisition
    wait(vid,pauseLen,'logging');
    %time(i)=now;
end


%End aotf
[chFRhex] = GetChRF(0,6, freq(1), 0);
[out] = sendHex2RF(ser,chFRhex);
[mastRFHex] = SetMasterRF(0,0);
[out] = sendHex2RF(ser,mastRFHex);
fclose(ser)
delete(ser)
clear ser;