function [fin_display] = finDisplay(len)
% Returns how many images should be shown to avoid black squares 
% on the montaged image. Its logic is based on testing how the montaged
% image looks like for n frames, and using instead k frames (with k as 
% close as possible to n)
% len should be the number of frames in the HSI
fin_display = len;

if (len == 3 || len == 4) 
    fin_display = 2;
end
if (len == 5 || len == 7 || len == 11 || len == 14 || len == 19) 
    fin_display = len + 1; %we show the background too
end
if (len == 9 || len == 10) 
    fin_display = 8;
end
if (len == 13) 
    fin_display = 12;
end 
if (len == 16 || len == 17 || len == 18) 
    fin_display = 15;
end
if (len>20)
    fin_display = 20;
end
end