/* In this file we initialize the AOTF driver*/


#include <iostream> 
#include <stdlib.h>
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <string>

using namespace std;

int SetMasterRF(char *mastRFHex, int liveflag,float PWlevel);

int initAOTF(int mPow){

	DCB dcb={0};
	HANDLE hCom;
	BOOL fSuccess;
	char *pcCommPort = "COM1";

	
	/***************************************CommTimeouts******************************************/
	COMMTIMEOUTS timeouts={0};
	timeouts.ReadIntervalTimeout=50;
	timeouts.ReadTotalTimeoutConstant=50;
	timeouts.ReadTotalTimeoutMultiplier=10;
	timeouts.WriteTotalTimeoutConstant=50;
	timeouts.WriteTotalTimeoutMultiplier=10;
	

	/*******************************************Handle*******************************************/
	hCom = CreateFile( pcCommPort,
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ,    // must be opened with exclusive-access
		NULL, // no security attributes
		OPEN_EXISTING, // must use OPEN_EXISTING
		FILE_ATTRIBUTE_NORMAL,    // not overlapped I/O
		NULL  // hTemplate must be NULL for comm devices
		);



	/***************************************SET*UP*COM*PORT**************************************/
	if (hCom == INVALID_HANDLE_VALUE)
	{
		printf ("CreateFile failed with error %d.\n", GetLastError());
		//return (1);
	}

	if(!SetCommTimeouts(hCom, &timeouts))
	{
		/*Well, then an error occurred*/
	}

	fSuccess = GetCommState(hCom, &dcb);

	if (!fSuccess)
	{
		/*More Error Handling*/
		printf ("GetCommState failed with error %d.\n", GetLastError());
		//return (2);
	}


	dcb.BaudRate = 9600;     // set the baud rate
	dcb.ByteSize = 8;             // data size, xmit, and rcv
	dcb.Parity = NOPARITY;        // no parity bit
	dcb.StopBits = ONESTOPBIT;    // one stop bit
	fSuccess = SetCommState(hCom, &dcb);

	if (!fSuccess)
	{
		printf ("SetCommState failed. Error: %d.\n", GetLastError());
		//return (3);
	}

	printf ("Serial port %s successfully configured.\n", pcCommPort);
	
	/********************************************************************************************/

	int i_retCode;
	char mastRFHex[12]="\0";

	i_retCode = SetMasterRF(mastRFHex, 0, mPow);




	/*
	[mastRFHex] = SetMasterRF(0,mPow);
	[out] = sendHex2RF(aotf,mastRFHex);*/


	return 0;

}


int SetMasterRF(char *mastRFHex, int liveflag,float PWlevel){

	int i_retCode=1;
	char fb[3];

	if(liveflag == 0)
		strcpy(fb,"05");
	else
		strcpy(fb,"06");


	char hexPower[3]="00";
	if( PWlevel < 100 ){

		int power;
		float prod;
		prod = PWlevel*255/100;
		prod = round(prod);

		power = static_cast<int>(prod);

		int aux,i=1;
		while(power!=0 && i>0){
			aux = power % 16;

			//To convert integer into character
			if( aux < 10) 
				aux =aux + 48; 
			else
				aux = aux + 55;

			hexPower[i]= aux;
			i--;
			power = power / 16;
		}
	}
	else
		i_retCode = 0;

	strcat(mastRFHex, fb);
	strcat(mastRFHex, "81");
	strcat(mastRFHex, hexPower);
	strcat(mastRFHex, "000000");

	return i_retCode;
}