% initAOTF


function [aotf] = initAOTF(mPow)
%HSI acquisition function for AOTF G&H - modified version because of frame
%problems
% INPUT:
%   mPow - master channel power (0-100)

% OUTPUT:
%   ser - AOTF file controller
% 

%init AOTF
[info, N] = FindDevice;
serNum = info(end); %obtained from FindDevice
serName = ['COM',num2str(serNum)];
aotf = serial(serName,'BaudRate',9600,'DataBits',8,'Parity','none','StopBits',1,'FlowControl','none','Terminator','CR');
fopen(aotf);
[mastRFHex] = SetMasterRF(0,mPow);
[out] = sendHex2RF(aotf,mastRFHex);

path = 'C:\Users\hyspex\Documents\MATLAB\Variables\aotf.mat';
save(path, 'aotf'); 

end