/*********************************************************************
* int resul = mCloseCamera(double handle);

* Close camera and finalise library.
********************************************************************/
#include <matrix.h>
#include <mex.h>   
#include "atcore.h"
#include <iostream> 
#include "stdlib.h"

using namespace std;

void mexFunction(int nlhs, mxArray *plhs[], 
	int nrhs, const mxArray *prhs[])
{
	double *handle, *d_retCode;
	mxArray *resul_out;
	
    /* Get input and allocate memory for output*/
	handle = mxGetPr(prhs[0]);
	d_retCode = static_cast<double *> (mxMalloc(sizeof(d_retCode)));	

	AT_H Hndl;
	Hndl = static_cast<AT_H> (*handle);		

    /*Close camera and write the return code to the output*/
	d_retCode[0] = static_cast<double> (AT_Close(Hndl));                                                      

    /*Finalise library*/
	AT_FinaliseLibrary();
						
    /*Output*/
	plhs[0] = mxCreateDoubleMatrix(1, 1, mxREAL);
	resul_out = plhs[0];
	mxSetPr(resul_out, d_retCode);
}
