/*********************************************************************
* Enable cooling 
* 
* double status = mCooling(double handle, double action);

action:
1: turn on the cooling
0: turn off the cooling
2: get the cooling status

status:
0 cool off
1 cool on
2 error
********************************************************************/
#include <matrix.h>
#include <mex.h>   
#include "atcore.h"
#include <iostream> 
#include "stdlib.h"
using namespace std;

void cooling(char *status_out, double handle, double action);

void mexFunction(int nlhs, mxArray *plhs[], 
	int nrhs, const mxArray *prhs[])
{
	char *status_out; 
	double *handle, *action;	
    
    /*Get inputs*/
	handle = mxGetPr(prhs[0]);
	action = mxGetPr(prhs[1]);

	/*Allocate memory for output*/
	status_out = static_cast<char *>(mxCalloc(256, sizeof(char)));

    /*Call cooling function*/
	cooling(status_out, *handle, *action);

    /*Output*/
	plhs[0] = mxCreateString(status_out);
	
	return;
}

void cooling(char *status_out, double handle, double action){

	int i_retCode=-1, temperatureStatusIndex = 0, temperatureCount = 0;
    double temperature = 0;
	AT_H Hndl;
	Hndl = static_cast<AT_H> (handle);
	    
    /*Perform action*/
	if(action==1){
	i_retCode = AT_SetBool(Hndl, L"SensorCooling", AT_TRUE);
	}
	if(action==0){
	i_retCode = AT_SetBool(Hndl, L"SensorCooling", AT_FALSE);
	}
    
    /*Print result*/
	if(i_retCode == AT_SUCCESS || i_retCode == -1){
		mexPrintf("Cooling function status: ");
	}
	else{
		mexPrintf("WARNING! Switching cooling status failed ");
	}
    /*Get status*/
	AT_WC temperatureStatus[256];
	AT_GetEnumIndex(Hndl, L"TemperatureStatus", &temperatureStatusIndex);
	AT_GetEnumStringByIndex(Hndl, L"TemperatureStatus", temperatureStatusIndex, temperatureStatus, 256);
	
	char tempStatus[256];
	wcstombs(tempStatus,temperatureStatus,512);
	mexPrintf("%s", tempStatus);

    /*Write the status in the output string*/
	int k;
    for ( k=0; k<256; k++){
        status_out[k] = tempStatus[k];
    }
}
	





