/*********************************************************************
* int resul = mExposureTime(double handle, double exposure_time);

* Change exposure time
********************************************************************/
#include <matrix.h>
#include <mex.h>   
#include "atcore.h"
#include <iostream> 
#include "stdlib.h"
using namespace std;


void mexFunction(int nlhs, mxArray *plhs[], 
	int nrhs, const mxArray *prhs[])
{
	double *handle, *exposure_time_in, *d_retCode, *exp_time_applied;
	mxArray *resul_out, *exp_out;
	int i_retCode;

	/*Get inputs*/
	handle = mxGetPr(prhs[0]);
	exposure_time_in = mxGetPr(prhs[1]);

	/*Allocate memory*/
	d_retCode = static_cast<double *> (mxMalloc(sizeof(d_retCode)));
	exp_time_applied = static_cast<double *> (mxMalloc(sizeof(d_retCode)));

	AT_H Hndl;
	Hndl = static_cast<AT_H> (*handle);		

	/*Set exposure time*/
	i_retCode = AT_SetFloat(Hndl, L"ExposureTime", *exposure_time_in);

	d_retCode[0] = 0; 
 
	/*Check that it has been successfully set*/
	AT_GetFloat(Hndl, L"ExposureTime", exp_time_applied);
	if (*exposure_time_in == *exp_time_applied && i_retCode == AT_SUCCESS){
		d_retCode[0] = 1;
		mexPrintf("Exposure time set to: %f", *exp_time_applied);
	}
	else
	{
		mexPrintf("WARNING!! ");
	}	                                                     

	/*Outputs*/
	plhs[0] = mxCreateDoubleMatrix(1, 1, mxREAL);
	resul_out = plhs[0];
	mxSetPr(resul_out, d_retCode);

	plhs[1] = mxCreateDoubleMatrix(1, 1, mxREAL);
	mxSetPr(plhs[1], exp_time_applied);
}
