/*********************************************************************
* int resul = mStopLiveView(double handle);
     *input: handle to camera
     *output: resul contains if the operation has been succesfull or not

* It ends the acquisition that has been going on to quickly get frames
* to be shown in live view mode. 
********************************************************************/
#include <matrix.h>
#include <mex.h>   
#include "atcore.h"
#include <iostream> 
#include "stdlib.h"
using namespace std;


void mexFunction(int nlhs, mxArray *plhs[], 
	int nrhs, const mxArray *prhs[])
{
	double *handle, *d_retCode;
	mxArray *resul_out;
	int i_retCode1, i_retCode2;

    /*Get input*/
	handle = mxGetPr(prhs[0]); 

    /*Allocate memory for output pointer*/
	d_retCode = static_cast<double *> (mxMalloc(sizeof(d_retCode)));	

    /*Hndl must be AT_H when passed to camera*/
	AT_H Hndl;
	Hndl = static_cast<AT_H> (*handle);		

    /*Give a value to the output it may be changed later*/
	d_retCode[0] = 0; 
	
    /*Stop acquisition and free the Queue buffer for next acquis*/
	i_retCode1 = AT_Command (Hndl, L"AcquisitionStop");
	i_retCode2 = AT_Flush(Hndl);

    /* Check if success */
	if (i_retCode1 == AT_SUCCESS && i_retCode2 == AT_SUCCESS){
		d_retCode[0] = 1;
		mexPrintf("Acquisition stopped");
	}
	else
	{
		mexPrintf("WARNING!! ");
	}	      
    /* Enable again Metadata Timestamp information in the frames*/
	i_retCode1 = AT_SetBool(Hndl, L"MetadataEnable", 1);
	i_retCode1 = AT_SetBool(Hndl, L"MetadataTimestamp", 1);

    /*Assign output value*/
	plhs[0] = mxCreateDoubleMatrix(1, 1, mxREAL);
	resul_out = plhs[0];
	mxSetPr(resul_out, d_retCode);
}
