 function [out] = sendHex2RF(ser,inst)
%Sends Hex instruction to G&H 16channel RF
% INPUT:
%   ser  - serial port ID
%   inst - a 6 bytes long Hex instruction as [hex1;...;hex6] structure

%{
serNum = 3; %obtained from FindDevice
serName = ['COM',num2str(serNum)];
ser = serial(serName,'BaudRate',9600,'DataBits',8,'Parity','none','StopBits',1,'FlowControl','none','Terminator','CR');
fopen(ser);

fclose(ser)
delete(ser)
clear ser;
%}

s.Timeout = 1;

%find inst structure length
N = size(inst,2);

for i = 1:N
    initI = inst{i};
    %sending command ended with CR = 13
    fwrite(ser, [uint8(hex2dec(initI));uint8(13)]);
end

out = 0;
end
