function varargout = userInterface(varargin)
% USERINTERFACE MATLAB code for userInterface.fig
%      USERINTERFACE, by itself, creates a new USERINTERFACE or raises the existing
%      singleton*.
%
%      H = USERINTERFACE returns the handle to a new USERINTERFACE or the handle to
%      the existing singleton*.
%
%      USERINTERFACE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in USERINTERFACE.M with the given input arguments.
%
%      USERINTERFACE('Property','Value',...) creates a new USERINTERFACE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before userInterface_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to userInterface_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help userInterface

% Last Modified by GUIDE v2.5 01-Jun-2015 16:32:19

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @userInterface_OpeningFcn, ...
                   'gui_OutputFcn',  @userInterface_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before userInterface is made visible.
function userInterface_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% Choose default command line output for userInterface
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = userInterface_OutputFcn(hObject, eventdata, handles) 
% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function acqui_CreateFcn(hObject, eventdata, handles)
exposure_time = 0.001; 
% Open the camera. Evalc allows us to get the "mexprintf("  ");" comments
% inside the mex file
message = evalc('[Hndl, fail] = mOpenCamera(exposure_time);'); 
if fail == 0
    action = 'on'; 
    status = cooling(Hndl, action); % activate the cooling mechanism
    setappdata(hObject,'Hndl',Hndl); % store the handle to camera as application data
end
setappdata(hObject,'message',message);

    

% --- Executes during object deletion, before destroying properties.
function acqui_DeleteFcn(hObject, eventdata, handles)
Hndl = getappdata(handles.acqui, 'Hndl');
resul = mCloseCamera(Hndl); % when the GUI is closed, the camera must be closed

% --- Executes on button press in acqui.
function acqui_Callback(hObject, eventdata, handles)
% this is an important function as it allows to acquire a hyperspectral image
% the wavelengths are specified through the buttons list or range
% it must show the HSI

list_o_rang = get(handles.list_o_rango, 'Value');
% check if we are defining the wavelength range with list or range
if list_o_rang == 0
    % We define the wavelength with the list
    contents = cellstr(get(handles.list,'String'));
    selection = get(handles.list,'Value');
        for i = 1:length(selection)    
             wavelen_string{i} = contents{selection(i)}(1:3);
             wavelengths(i) = str2double(wavelen_string{i});
        end
        
    %Now we have a vector wavelengths with the lambdas that we want (double)
    %and another with that number shown as a string
else 
    % We define the wavelength with the range
    lamb_start = str2double(get(handles.lamb_start,'String'));
    lamb_end   = str2double(get(handles.lamb_end,'String'));
    lamb_step  = str2double(get(handles.lamb_step,'String'));
    wavelengths = [lamb_start:lamb_step:lamb_end];
end

% the power of the sound wave can be changed as well
mPow = get(handles.power, 'String'); 
    if mPow(length(mPow))=='%'
    mPow = str2double(mPow(1:length(mPow)-1));
    else
        mPow = str2double(mPow);
    end

% if there is ROI information is not relevant anymore
if isappdata(hObject, 'ROI')==1 
    rmappdata(hObject, 'ROI');
end

% get handle to camera and show cooler status
Hndl = getappdata(handles.acqui, 'Hndl');
message  = getappdata(handles.acqui, 'message');
set(handles.Console,'String', message);
cooler_Callback(handles.cooler,[],handles);

%frequency in (MHz)
frequencies = (sqrt(sin(200./wavelengths)+1)).^(10.55)*20.91950466; 
Nlam = length(wavelengths);
Nlam = Nlam+1; % Nlam +1 because of the Background image 
 
% Allocating memory for the image cube and returned vectors. It speeds up
HSI = uint16(0);
HSI(2560,2162,Nlam)=0;
dimensions = uint32(0);
dimensions(1,7)=0;
timestamps = uint64(0);
timestamps(1,Nlam)=0;

if strcmp(get(handles.triggering_mode, 'String'), 'Software')
    [dimensions, HSI, timestamps] = mGetHSISoftware(Hndl, wavelengths);
else
    % Here the Hardware triggering procedure could be implemented
end

if HSI ~= 0
    % We store the image cube and its wavelengths info
    setappdata(hObject, 'HSI', HSI); 
    setappdata(hObject,'wavelengths',wavelengths); 

    % Depending on the number of pictures acquired the number of shown frames
    % will vary. It is because the displayed image looks better
    len = length(wavelengths);
    fin_display = finDisplay(len);
    list_images = num2cell(wavelengths);
    list_images{1, length(wavelengths)+1} = 'Background';
    set(handles.sel_pict, 'Value', 1); % Value must be in range
    set(handles.sel_pict, 'String', list_images);
    value = [1:fin_display];
    set(handles.sel_pict, 'Value', value);

    % Function to show several frames in the axis
    show_pict_Callback(handles.show_pict, [], handles);
else
    set(handles.Console,'String','HSI was not acquired!!')
end


% --- Executes on button press in liveView.
function liveView_Callback(hObject, eventdata, handles)
% This will usually be the first button the user presses. To focus the
% camera and point to the target. Live video should be displayed

test = get(hObject, 'String');
if strcmpi(test,'Live View')==1 % check if preview is ON
    %Activate preview
    list_o_rang = get(handles.list_o_rango, 'Value');
    if list_o_rang == 0
        % We define the wavelength with the list
        contents = cellstr(get(handles.list,'String'));
        selection = get(handles.list,'Value');    
        wavelen_string{1} = contents{selection(1)}(1:3);
        wavelength = str2double(wavelen_string{1});
    else 
        % We define the wavelength with the range
        wavelength = str2double(get(handles.lamb_start,'String'));
    end        
    mPow_str = get(handles.power, 'String');
    if mPow_str(length(mPow_str))=='%'
    mPow = str2double(mPow_str(1:length(mPow_str)-1));
    else
    mPow = str2double(mPow_str);
    end
    % CHECK
    %  AOTF
    % [ser]=initAOTF(mPow);
    % set(handles.Console,'String','AOTF and CAM initialized');

    %set frequency
%     liveflag = 0; channel = 6;
%     freq = Lam2Freq(wavelength);
    % [chFRhex] = GetChRF(liveflag, channel, freq, mPow); %%% MPOW SHOULD BE AMPLITUDE. CHECK
    % [out] = sendHex2RF(ser,chFRhex);

    if isappdata(hObject, 'ROI')==1
        rmappdata(hObject, 'ROI'); % the data from a former ROI is not relevant anymore
    end
    Hndl = getappdata(handles.acqui, 'Hndl'); % get the handle for camera
    message  = getappdata(handles.acqui, 'message');
    set(handles.Console,'String', message);
    cooler_Callback(handles.cooler,[],handles); % show cooler status

    % Change the button string to Stop Preview, it will change the
    % behaviour of the callback next time it's pressed
    set(hObject,'FontSize',10); 
    set(hObject,'String','Stop Preview');

    
    axes(handles.display);
    set(handles.display,'Position', [66 11.385 144 65.4615]);
    set(handles.display, 'ButtonDownFcn', {@display_ButtonDownFcn, handles}); 
    
    resul = mSetLiveView(Hndl); % camera settings previous to LiveView
    if resul == 1
        HSI = uint16(0);
        HSI(2560,2160)=0; % allocating memory for the frame        
        dimensions=uint32([2160 2560 11059200]); % setting the dimensions 
        %of the frame that will be acquired
        
        % Loop: a frame is obtained and shown until Stop Preview is pressed
        while strcmp(get(hObject,'String'), 'Stop Preview')==1            
            tic,
            message = evalc('HSI = mGetFrameLiveView(Hndl, dimensions);')            
            handles.display = imshow(imadjust(HSI));   
            drawnow;    
            toc 
            % tic, toc shows in console the time required to execute the
            % sequence between tic and toc. I've used it to optimize speed
            % many times. It is left here as a reminder: the LiveView
            % function can probably be optimized through "Circular Buffers"
            % as explained.
        end    
    end
    
else % Stop Preview (not Live View) has been pressed
    Hndl = getappdata(handles.acqui, 'Hndl');
    resul = mStopLiveView(Hndl);
    set(handles.Console,'String','Closed AOTF. Stopped preview');
    set(hObject,'FontSize',13);
    set(hObject,'String','Live View');
end


function lamb_start_Callback(hObject, eventdata, handles)
% Validate that the text in the lamb_start field converts to a real number
lamb_start = str2double(get(hObject,'String'));
if isnan(lamb_start) || ~isreal(lamb_start) || lamb_start < 400 || lamb_start > 1000
    % isdouble returns NaN for non-numbers and lamb_start cannot be complex
    % Disable the Acquire button and explain why in the GUI console
    set(hObject,'String','Error')
    set(handles.acqui,'Enable','off')
    set(handles.Console,'String','Start must be a number between 400 and 1000')
    % Give the edit text box focus so user can correct the error
    uicontrol(hObject)
else 
    % Enable the Acquire button with its original name
    set(handles.acqui,'Enable','on')
    uicontrol(handles.lamb_end)
end


function lamb_end_Callback(hObject, eventdata, handles)
% Validate that the text in the lamb_end field converts to a real number
lamb_end = str2double(get(hObject,'String'));
if isnan(lamb_end) || ~isreal(lamb_end) || lamb_end < 400 || lamb_end > 1000
    % isdouble returns NaN for non-numbers and lamb_start cannot be complex
    % Disable the Acquire button and explain why in the GUI console
    set(hObject,'String','Error')
    set(handles.acqui,'Enable','off')
    set(handles.Console,'String','End must be a number between 400 and 1000')
    % Give the edit text box focus so user can correct the error
    uicontrol(hObject)
else  
    % Enable the Acquire button with its original name
    set(handles.acqui,'Enable','on')
    uicontrol(handles.lamb_step)
end


function lamb_step_Callback(hObject, eventdata, handles)
lamb_step = str2double(get(hObject,'String'));
if isnan(lamb_step) || ~isreal(lamb_step) || lamb_step < 0 || lamb_step > 1000
    % isdouble returns NaN for non-numbers and lamb_start cannot be complex
    % Disable the Plot button and explain why in the GUI console
    set(hObject,'String','Error')
    set(handles.acqui,'Enable','off')
    set(handles.Console,'String','Step must be a number between 400 and 1000')
    % Give the edit text box focus so user can correct the error
    uicontrol(hObject)
else 
    % Enable the Plot button with its original name
    set(handles.acqui,'Enable','on')
    uicontrol(handles.acqui);
end


% --- Executes on button press in list_o_rango.
function list_o_rango_Callback(hObject, eventdata, handles)
% selects if the wavelenghts vector is defined as a list or a range
state = get(hObject, 'Value');
if state == 0
    % List mode enabled
    set(hObject,'String','List');
    set(handles.lamb_start,'Enable','off');
    set(handles.lamb_end,'Enable','off');
    set(handles.lamb_step,'Enable','off');
    set(handles.list,'Enable','on');
else 
    % Range input enabled
    set(hObject,'String','Range');
    a = double.empty(1,0);
    set(handles.list,'Value', a); %we take out the selection
    set(handles.list,'Enable','off');
    set(handles.lamb_start,'Enable','on');
    set(handles.lamb_end,'Enable','on');
    set(handles.lamb_step,'Enable','on');
end


function power_Callback(hObject, eventdata, handles)
%This callback should allow to change the power 
% of the signal generated by the driver (not finished)

power_str = get(hObject,'String');
% Value of power is get no matter if symbol % is typed or not
if power_str(length(power_str))=='%'
    power = str2double(power_str(1:length(power_str)-1));
else
    power = str2double(power_str);
end

if isnan(power) || ~isreal(power) ||  power > 100 
    % isdouble returns NaN for non-numbers and lambda cannot be complex
    % Disable the Plot button 
    set(hObject,'String','Error');
    set(handles.liveView,'Enable','off');
    % Give the edit text box focus so user can correct the error
    uicontrol(hObject)
else 
    % Enable the Plot button with its original name
    set(handles.liveView,'Enable','on');
    power_str = strcat(num2str(power), '%');
    set(hObject,'String',power_str)
    
    wavelength = str2double(get(handles.liveV_wavelength,'String'));
    
    path_root = get(handles.path_STARTING_POINT, 'UserData');
    path = [path_root '\ser.mat'];
    load(path);

%     %set frequency CHECK
%     liveflag = 0; channel = 6;
%     freq = Lam2Freq(wavelength);
%     [chFRhex] = GetChRF(liveflag, channel, freq, power); %%% MPOW SHOULD BE AMPLITUDE. CHECK
%     [out] = sendHex2RF(ser,chFRhex);
end


% --- Executes during object creation, after setting all properties.
function Console_CreateFcn(hObject, eventdata, handles)
% This is a small console where info can be shown
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[0.9 0.9 0.9]); %that is grey color
end
set(hObject,'String','Remember to turn on Camera and AOTF');


% --- Executes on button press in restart.
function restart_Callback(hObject, eventdata, handles)
% Camera is closed and opened again, AOTF should be as well
mModifiedCloseCamera();
acqui_CreateFcn(handles.acqui, [], handles) 
%Here AOTF
 %
 % 
 
 
% --- Executes on button press in subs.
function subs_Callback(hObject, eventdata, handles)
% The Background frame is substracted to all the others. Its behaviour 
% changes if we press again the button: Add Bkg
HSI = getappdata(handles.acqui, 'HSI'); 
%HSI without substracting is kept in case operation must be undone
setappdata(handles.acqui, 'undo', HSI);

wavelengths = getappdata(handles.acqui, 'wavelengths'); 

if wavelengths==0 % if wavelengths is empty so is HSI
    set(handles.Console, 'String', 'You must load an HSI first');
else
     Nlam = length(HSI(1,1,:));

    if strcmp(get(hObject, 'String'), 'Subs Bkg')%substraction
        for i=1:Nlam-1
            HSI(:,:,i) = (HSI(:,:,i)-HSI(:,:,Nlam));
        end
        set(hObject, 'String', 'Add Bkg'); % behaviour can be changed
    else
        for i=1:Nlam-1
            HSI(:,:,i) = (HSI(:,:,i)+HSI(:,:,Nlam));%adding
        end
        set(hObject, 'String', 'Subs Bkg');
    end

    setappdata(handles.acqui, 'HSI', HSI); 
    
    show_pict_Callback(handles.show_pict, [], handles);% show it
end


% --- Executes on button press in show_pict.
function show_pict_Callback(hObject, eventdata, handles)
% It shows the current HSI or the current ROI
axes(handles.histH); cla reset; set(handles.histH,'Visible', 'off'); 
axes(handles.histV); cla reset; set(handles.histV,'Visible', 'off');
axes(handles.display); cla reset; % axes must be resets

% get the current HSI or ROI(if any)
if isappdata(handles.acqui, 'ROI') == 0
    HSI = getappdata(handles.acqui,'HSI'); 
    wavelengths = getappdata(handles.acqui,'wavelengths'); 
else
    ROI = getappdata(handles.acqui,'ROI'); 
    HSI = ROI.little_img;
    wavelengths = ROI.wavelengths;
end
    
    
if wavelengths==0 % if wavelengths is empty so is HSI now
    set(handles.Console, 'String', 'You must load or take a HSI first');
else
    % only the selected frames in the listbox are shown
    contents = cellstr(get(handles.sel_pict,'String'));
    selection = get(handles.sel_pict,'Value');
    wavelengths = 0;
    for i = 1:length(selection)    
         wavelengths(i) = str2double(contents{selection(i)});
         selected(:,:,i) = HSI(:,:, selection(i));
    end
    
    if length(selection) == 1 % if there is only one frame to show
        %we just use the matlab function imshow
        set(handles.display,'Position', [66 11.385 144 65.4615]);
        selected = imadjust(squeeze(selected));
        
        axes(handles.display);
        handles.display = imshow(selected);
        pixelInfo = impixelinfo(handles.display);
        set(pixelInfo,'Position', [180 100 150 23]);
        
        % if we are showing only one frame, its stored as Selected frame
        % to be used if pixel Histogram is required
        set(handles.roi,'Enable', 'on');
        setappdata(handles.acqui,'Selected_frame', selected); 
                
        set(handles.display, 'ButtonDownFcn', {@display_ButtonDownFcn, handles}); 
               
    else % if there are more than one we call our function showImages
        set(handles.display,'Position', [-0.2 5.154 268.2 71.77]);
        
        axes(handles.display);
        handles.display = showImages(selected);
        
        if isappdata(handles.acqui, 'Selected_frame')
            rmappdata(handles.acqui, 'Selected_frame');
        end
    end
   
end
  

% --- Executes on mouse press over axes background.
function display_ButtonDownFcn(hObject, eventdata, handles)
   % Histogram of the pixel the user clicks on is shown in new axes 
   if isappdata(handles.acqui, 'Selected_frame')
       % Get the single frame shown (not a montage of several frames)
       frame = getappdata(handles.acqui, 'Selected_frame');
       
       axesHandle  = get(hObject,'Parent');
       coordinates = get(axesHandle,'CurrentPoint'); % get coordinates
       coordinates = round(coordinates(1,1:2));
       
       set(handles.histH,'Visible', 'on'); % enable histH and histV axis
       set(handles.histV,'Visible', 'on');
       
       % Get the data of the full row and column the pixel belongs to
       H_plot = [];
       V_plot = [];       
       H_plot = double(frame(coordinates(2), :))./65535;
       V_plot = double(frame(:, coordinates(1)))./65535;
       
       % Plot them
       H = [1:length(H_plot)];
       axes(handles.histH);       
       plot(H, H_plot, 'LineStyle', '-', 'Color', [1 0.5 0]);
       axis([0 2160 0 1])
       set(handles.histH,'Color', [0.9 0.9 0.9]);

       V = [1:length(V_plot)];
       axes(handles.histV);
       plot(V_plot, V, 'LineStyle', '-', 'Color', [1 0.5 0]);
       axis([0 1 0 2560])
       set(handles.histV,'Color', [0.9 0.9 0.9]);
   end

% --- Executes on button press in roi.
function roi_Callback(hObject, eventdata, handles)
% It allows to select a region of interest in the acquired HSI 

% Get the data we are going to work with
HSI = getappdata(handles.acqui,'HSI'); 
wavelengths = getappdata(handles.acqui,'wavelengths'); 
if isappdata(handles.acqui,'ROI')
    HSI = getappdata(handles.acqui,'ROI');
    HSI = HSI.little_img;
end
if isappdata(handles.acqui,'Selected_frame')
    img = getappdata(handles.acqui,'Selected_frame'); 
else
    img(:,:) = imadjust(squeeze(HSI(:,:,1)));
    set(handles.sel_pict, 'Value', 1);
end

if wavelengths ~= 0 % if wavelengths is not empty
    axes(handles.display);
    mask = roipoly(img); % draw the ROI
    % Get coordinates of ROI and define a small rectangle including the ROI
    [row col] = find(mask);
    xmin = col(1);
    xmax = col(length(col));
    ymin = min(row);
    ymax = max(row);

    umask = ~mask;

    Nlam = length(wavelengths)+1;
    % Prepare the mask to filter and keep only the ROI
    little_mask = mask(ymin:ymax, xmin:xmax); 
    little_umask = ~little_mask; 
    % allocate memory for the small image that will 
    % contain the ROI of the normal image
    little_img = zeros(ymax-ymin+1, xmax-xmin+1, Nlam, 'uint16');

    % Filter
    for i=1:Nlam
     little_img(:,:,i) = HSI(ymin:ymax, xmin:xmax, i);  
     low(i) = min(min(little_img(:,:,i)));

     h=[0];      %%%CHECK Useful code to filter ROI
     little_img(:,:,i) = roifilt2(h, squeeze(little_img(:,:,i)), little_umask); 
%          [row col] = find(little_img(:,:, 1, i));
%          for k=1:length(col)
%             pixels_in_ROI(k) = little_img(row(k),col(k), 1, i);
%          end
     high(i) = max(max(little_img(:,:,i)));
%         h=[1];      %%% Useful code to filter ROI
%         img(:,:,1,i) = roifilt2(h, img(:,:,1,i), mask); 
    end        
    % Store parameters associated to ROI as a struct
    ROI = struct('HSI', HSI, 'wavelengths', wavelengths, 'mask', mask, 'little_img', little_img, 'little_mask', little_mask);
    setappdata(handles.acqui,'ROI', ROI);

    show_pict_Callback(handles.show_pict, [], handles);% show the filtered images
else % if there are none or more than one frames selected (shown)
    set(handles.Console, 'String', 'You must load an HSI first, and select one frame!');
end


% --- Executes on button press in full_Image.
function full_Image_Callback(hObject, eventdata, handles)
% After defining a ROI this function allows us to come back to the original
% full size image: by deleting the ROI information, show_pict does the rest
if isappdata(handles.acqui, 'ROI')
    rmappdata(handles.acqui, 'ROI');  
end
if isappdata(handles.acqui, 'Seleceted_frame')
    rmappdata(handles.acqui, 'Seleceted_frame');  
end
show_pict_Callback(handles.show_pict, [], handles);


% --- Executes on button press in cooler.
function cooler_Callback(hObject, eventdata, handles)
% this function gets the status of the cooling function from the camera and
% display it on the cool_status
Hndl = getappdata(handles.acqui, 'Hndl');
action = 'get';
message = evalc('status = cooling(Hndl, action);');
set(handles.cool_status, 'String', '............');
pause(0.1);
set(handles.cool_status, 'String', status);
set(handles.Console, 'String', message);


% --- Executes during object creation, after setting all properties.
function path_starting_point_CreateFcn(hObject, eventdata, handles)
%We need to have a .mat file with a string variable called path_STARTING_POINT
%Then we store it as a property of path_STARTING_POINT and we can get it.
path = 'C:\Users\vnir1600\Documents\MATLAB\Variables\path.mat';%%%CRITIC PATH POINT
load(path);
set(hObject,'UserData', path); 

% --- Executes on button press in path_starting_point.
function path_starting_point_Callback(hObject, eventdata, handles)
%Store the current path_STARTING_POINT in the property UserData so that we can get it.
%If user presses this button, new path_STARTING_POINT will be selected
path = uigetdir();
if path ~= 0
    cd(path);
    path_variable = [path '\path.mat']
    save(path_variable, 'path');
    set(hObject,'UserData', path); 
end


% --- Executes on button press in pixelRegion.
function pixelRegion_Callback(hObject, eventdata, handles)
% it allows to use Matlab functionality impixelregion to have 
% a closer look at the pixels of an image
pixelRegion = impixelregion(handles.display);
set(pixelRegion,'Position', [1280 10 600 360]);


% -----Executed if user presses save icon (in the top left)--------
function save_icon_ClickedCallback(hObject, eventdata, handles)
% Saves a HSI as .mat file to harddrive it takes some time, it provides an
% standard name but the user can change it

% Get an standard name: HSimag + date
id_time = timeString(1);
path_ima = get(handles.path_starting_point, 'UserData');
Images_string = '\Images    ';
path_ima(35:44)=Images_string(1:10);
path = strcat(path_ima, '\HSimag', id_time,'.mat');
if exist(path, 'file') == 2 % if we take HSI in the same minute they will have the same name and 
   path = strcat(path_ima, '\HSimag', id_time,'a','.mat');
    if exist(path, 'file') == 2 % we would overwrite the last one. With this code that is avoided
        path = strcat(path_ima, '\HSimag', id_time,'b','.mat');
            if exist(path, 'file') == 2
             path = strcat(path_ima, '\HSimag', id_time,'c','.mat');
            end
    end
end
% Let the user choose if he wants the standard or another
[FileName,PathName] = uiputfile(' ', 'Select a file to save HSI in: ', path);
if ischar(FileName) && ischar(PathName) 
    HSI = getappdata(handles.acqui,'HSI');
    wavelengths = getappdata(handles.acqui,'wavelengths');
    path = [PathName FileName];
    save(path, 'HSI', 'wavelengths');
    set(handles.Console,'String', 'HSI stored');
else
    set(handles.Console,'String', 'You must select a valid path');
    save_icon_ClickedCallback(hObject, [], handles);
end


% -----Executed if user presses open icon (in the top left)--------
function open_icon_ClickedCallback(hObject, eventdata, handles)
% it allows to open a HSI stored as .mat file, it first open the "usual"
% folder but the user can choose
path_root = get(handles.path_starting_point, 'UserData');
Images_string = '\Images    ';
path_root(35:44) = Images_string(1:10);

[file path] = uigetfile('*.mat', 'Select HyperSpectral Image', path_root);
if ischar(file) && ischar(path) 
    path = strcat(path, file);
    load(path);

    if isappdata(hObject, 'ROI')==1
        rmappdata(hObject, 'ROI');
    end
    setappdata(handles.acqui, 'HSI', HSI); 
    setappdata(handles.acqui,'wavelengths',wavelengths); 

    % We update the List Box with the images and call show_pict_Callback
    len = length(wavelengths);
    fin_display = finDisplay(len);
    list_images = num2cell(wavelengths);
    list_images{1, length(wavelengths)+1} = 'Background';
    set(handles.sel_pict, 'Value', 1); % Value must be in range
    set(handles.sel_pict, 'String', list_images);
    value = [1:fin_display];
    set(handles.sel_pict, 'Value', value);

    show_pict_Callback(handles.show_pict, [], handles)
else
    set(handles.Console,'String', 'You must select a valid file');
    open_icon_ClickedCallback(hObject, [], handles);
end


% --- Executes on button press in spectrum.
function spectrum_Callback(hObject, eventdata, handles)
% If User has selected one or several pixels, their spectrum (the value of 
% the pixel for the different frames is plotted.
content = get(handles.list_pix,'String');
if ~strcmp(content, 'Select first ^')
    if isappdata(handles.acqui, 'Selected_frame')
    rmappdata(handles.acqui, 'Selected_frame'); % so that it doesnt fail if we click select again
    end
    
    selected = get(handles.list_pix,'Value');
    row_col = get(handles.list_pix, 'UserData');
    for i=1:length(selected)
        row(i) = row_col.row(selected(i));
        col(i) = row_col.col(selected(i));
    end

    if ~isempty(row) && ~isempty(col)
        HSI = getappdata(handles.acqui, 'HSI');
        wavelengths = getappdata(handles.acqui, 'wavelengths');

        for i=1:length(selected) % get spectrum
            spectrum(i,:) = HSI(row(i), col(i), :);
            %spectrum2(i,:) = HSI(:, col(i), row(i));
        end
        axes(handles.display); cla reset; % axes must be reset
        
        % Plot all the spectrums
        axes(handles.display);
        for i=1:length(selected)
        plot(wavelengths, spectrum(i,1:length(wavelengths)));
        hold on    
        end  
        axis('fill');
    end
end


% --- Executes on button press in select_pixels.
function select_pixels_Callback(hObject, eventdata, handles)
 % User can select some pixel in a frame to after that plot their spectrum.
 % Requires that there is only one frame shown
 % (to make possible the pixel selection).
    
 axes(handles.display);

if isappdata(handles.acqui, 'Selected_frame')
       
       frame = getappdata(handles.acqui, 'Selected_frame');
       
       [col row ~] = impixel();
       
       for i=1:length(col)
           list {1, i} =  ['(' num2str(row(i)) ', ' num2str(col(i)) ')']; 
       end
       
       set(handles.list_pix, 'Value', 1); % Value must be in range
       set(handles.list_pix, 'String', list);
       row_col = struct('row', row, 'col', col);
       set(handles.list_pix, 'UserData', row_col);
else
    set(handles.Console, 'String', 'You must have a single frame first');
end


% --- Executes on button press in triggering_mode.
function triggering_mode_Callback(hObject, eventdata, handles)
% It allows to select the triggering mode 
string = get(hObject, 'String');
if strcmp(string,'Software') == 1
    set(hObject,'String','Hardware');    
else 
    set(hObject,'String','Software');
end

function exposureTime_Callback(hObject, eventdata, handles)
Hndl = getappdata(handles.acqui, 'Hndl');
exposure_time = get(hObject, 'String');
set(hObject, 'String', '.....');
pause(0.1);
exposure_time = str2double(exposure_time);
message = evalc('[resul, exp_applied] = mExposureTime(Hndl,  exposure_time);');
set(hObject, 'String', num2str(exp_applied));
set(handles.Console, 'String', message);
